#!/usr/bin/python
# 
# Copyright (C) 2009, Intel Corporation.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.  
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307 USA.
#
# Authors:
#              Wei, Zhang <wei.z.zhang@intel.com>
#

import sys
import os

sys.path.append('../../tetj/')
from tetj import *

from bm_xulrunner_version import xulrunner_version_check

# Test body
def _test():
    # Check command line parameters
    if (len(sys.argv) == 3) and (sys.argv[1] == '-j'):
        journal_file = sys.argv[2]
    else:
        sys.stderr.write('Usage: %s -j journal_file\n' % sys.argv[0])
        sys.exit(1)

    try:
	journal = Journal(journal_file, 'Moblin Compliance Test')
    except:
        sys.stderr.write('Cannot create journal file : %s\n' % journal_file)
	sys.exit(1)

    journal.add_config('VSX_NAME=moblin compliance test suites(%s)' % journal.machine)
    journal.config_end()
 
    # Browser Start
    # =================
    journal.testcase_start('Browser-Test')

    # xulrunner version
    # -----------------------
    journal.purpose_start()
    info = 'Checked requirement: Xulrunner Version\n'
    ret = TETJ_FAIL
    try:
        p = xulrunner_version_check()
        info += p[1]
        ret = p[0]
    except:
        info += "\nException on testing"
    journal.testcase_info(0, 0, 0, info)
    journal.result(ret)
    journal.purpose_end()

    # Browser End
    # =================
    journal.testcase_end()
    journal.close()


if __name__ == '__main__':
    _test()
