
/*
# 
# Copyright (C) 2009, Intel Corporation.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms and conditions of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
#
# This program is distributed in the hope it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.  
#
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307 USA.
#
# Authors:
#              Qin, Mu <qin.mu@intel.com>
#
*/


var pass = 0, fail = 0, error = 0, index = 0 , total = 0, delay = 6000;
var log = '';
var src = "data/";
var testResults = new Array();


var tests = [
  
function testEventTarget()
{    
    total += 1;
    
    var request = getRequest();
    function func(evt) {
    }
    ;
    try {
        request.addEventListener("readystatechange", func, false);
        testResults['readystatechange'] = 'p';   
    }
    catch(e) {
        testResults['readystatechange'] = e.message;     
        }
    request.open("GET", src + "response_text.html", true);
    request.send(null);
},

function testAsyncOnReadyStateChange()
{
   total += 1;
   var request = getRequest();
    request.onreadystatechange = function()
    {
            if (request.readyState == 4 && request.status == 200) {
            testResults['testAsyncOnReadyStateChange'] = 'p';   
           }
           else
           	testResults['testAsyncOnReadyStateChange'] = 'f';   
    };
    request.open("GET", src + "response_text.html", true);
    request.send(null);
},


function testResponseTextReadyState()
{
    
   total += 4;
    var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 1) {
            try {
                if (request.responseText.length > 0) {
                	testResults["testResponseTextEmptyReadyState1"] = 'f';
                }
                else {
                    testResults["testResponseTextEmptyReadyState1"] = 'p';
                }
            }
            catch(e) {
                testResults["testResponseTextEmptyReadyState1"] = e.message;            
                }
        }
        else if (request.readyState == 2) {
            try {
                if (request.responseText.length > 0) {
                	testResults["testResponseTextEmptyReadyState2"] = 'f';
                }
                else {
                    testResults["testResponseTextEmptyReadyState2"] = 'p';
                }
            }
            catch(e) {
                 report("testResponseTextEmptyReadyState2 fail");
            }
        }
        else if (request.readyState == 3) {
            try {
                if (request.responseText.length >= 0) {
                    testResults["testResponseTextEmptyReadyState3"] = 'p';
                }
                else {
                	testResults["testResponseTextEmptyReadyState3"] = 'f';
                }
            }
            catch(e) {
                 report("testResponseTextEmptyReadyState3 exception" + e.message);
            }
        }
        else if (request.readyState == 4) {//alert (eval(request.responseText));
            if ( request.responseText.length >=  0) {
            
                    testResults["testResponseTextEmptyReadyState4"] = 'p';
            }
            else {
                	testResults["testResponseTextEmptyReadyState4"] = 'f';
            }
        }

    };
    request.open("GET", src + "response_text.html", true);
    request.send(null);
},


function testResponseXmlReadyState()
{
    
    total += 3;
   var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 1) {
            try {
                if (request.responseXML == null) {
                    testResults["testResponseXmlEmptyReadyState1"] = 'p';
                }
                else {
                      testResults["testResponseXmlEmptyReadyState1"]='f';
                }
            }
            catch(e) {
                      testResults["testResponseXmlEmptyReadyState1"]=e.message;
            }
        }
        else if (request.readyState == 2) {
            try {
                if (request.responseXML == null) {
                    testResults["testResponseXmlEmptyReadyState2"]='p';
                }
                else {
                      testResults["testResponseXmlEmptyReadyState2"]='f';
                }
            }
            catch(e) {
                     testResults["testResponseXmlEmptyReadyState2"]=e.message;
            }
        }
        else if (request.readyState == 3) {
            try {
                if (request.responseXML == null) {
                    testResults["testResponseXmlEmptyReadyState3"]='p';
                }
                else {
                     testResults["testResponseXmlEmptyReadyState3"]='f';
                }
            }
            catch(e) {
                      testResults["testResponseXmlEmptyReadyState3"]=e.message;
            }
        }
    };
    request.open("GET", src + "response_xml.xml", true);
    request.send(null);
},

function testResponseXmlParsed()
{
   total += 1;
    var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 4) {
            try {
               if ("send" == request.responseXML.documentElement.nodeName) {
                    testResults["testResponseXmlParsed"]='p';
                }
                else {
                    testResults["testResponseXmlParsed"]='f';
                }
            }
            catch(e) {
                    testResults["testResponseXmlParsed"]=e.message;
            }
        }
    };
    request.open("GET", src + "response_xml.xml", true);
    request.send(null);
},

function testResponseXmlNoContentType()
{
    
   total += 1;
    var r1 = getRequest();
    r1.onreadystatechange = function()
    {
        if (r1.readyState == 4) {
            try {
                if (r1.responseXML == null) {
                    testResults["testResponseXmlNoContentType"]='p';
                }
                else {
                 testResults["testResponseXmlNoContentType"]='f';
                }
            }
            catch(e) {
                testResults["testResponseXmlNoContentType"]=e.message;
;
            }
        }
    };
    r1.open("GET", src + "response_xml_no_contenttype.html", true);
    r1.send(null);
    
  /*     
    var r2 = getRequest();
    r2.onreadystatechange = function()
    {
        if (r2.readyState == 4) {
        
            try {
                if (r2.responseXML == null) {             
                    testResults["testResponseXmlNotParsed"]='p';
                }
                else {
                  testResults["testResponseXmlNotParsed"]='f';

                }
            }
            catch(e) {
                 testResults["testResponseXmlNotParsed"]=e.message;

            }
        }
    };
    r2.open("GET", src + "response_invalid_xml.xml", true);
    r2.send(null);
  */  
},


function testStatusReadyState()
{
    
   total += 4;
    var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 1) {
            try {
                if (request.status == 200) {
                    testResults["testStatusReadyState1"]='p';
                }
                else {
                   testResults["testStatusReadyState1"]='f';

                }
            }
            catch(e) {
                testResults["testStatusReadyState1"]='p';
            }
        }
        else if (request.readyState == 2) {
            try {
                if (request.status == 200) {
                    testResults["testStatusReadyState2"]='p';
                }
                else {
                    testResults["testStatusReadyState2"]='f';
                }
            }
            catch(e) {
                    testResults["testStatusReadyState2"]='p';
            }
        }
        else if (request.readyState == 3) {
            try {
                if (request.status == 200) {
                    testResults["testStatusReadyState3"]='p';
                }
                else {
                    testResults["testStatusReadyState3"]='f';
                }
            }
            catch(e) {
                    testResults["testStatusReadyState3"]='f';

            }
        }
        else if (request.readyState == 4) {
            try {
                if (request.status == 200) {
                    testResults["testStatusReadyState4"]='p';
                }
                else {
                    testResults["testStatusReadyState4"]='f';
                }
            }
            catch(e) {
                    testResults["testStatusReadyState4"]='f';
             }
        }
    };
    request.open("GET", src + "response_text.html", true);
    request.send(null);
},

function testStatusTextReadyState()
{
    
   total += 4;
    var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 1) {
            try {
                if (request.statusText == "OK") {
                    // Available - so no exception
                    testResults["testStatusTextReadyState1"]='p';
                }
                else {
                    testResults["testStatusTextReadyState1"]='f';
                  }
            }
            catch(e) {
                    testResults["testStatusTextReadyState1"]='p';
            }
        }
        else if (request.readyState == 2) {
            try {
                if (request.statusText == "OK") {
                    // Available - so no exception
                    testResults["testStatusTextReadyState2"]='p';
                }
                else {
                    testResults["testStatusTextReadyState2"]='f';
                }
            }
            catch(e) {
                    testResults["testStatusTextReadyState2"]='p';
            }
        }
        else if (request.readyState == 3) {
            try {
                if (request.statusText == "OK") {
                    testResults["testStatusTextReadyState3"]='p';
                }
                else {
                    testResults["testStatusTextReadyState3"]='f';
                }
            }
            catch(e) {
                    testResults["testStatusTextReadyState3"]='f';
                
            }
        }
        else if (request.readyState == 4) {
            try {
                if (request.statusText == "OK") {
                    testResults["testStatusTextReadyState4"]='p';
                }
                else {
                    testResults["testStatusTextReadyState4"]='f';
                }
            }
            catch(e) {
                    testResults["testStatusTextReadyState4"]='f';
            }
        }
    };
    request.open("GET", src + "response_text.html", true);
    request.send(null);
},

function testAbort()
{
    total += 1;
   var request = getRequest();
    var aborted = false;
    request.onreadystatechange = function()
    {
        if (request.readyState > 1) {
            if (!aborted) {
                try {
                    request.abort();
                    if (request.readyState == 0) {
                        testResults["testAbort"]='p';
                    }
                    else {
                        testResults["testAbort"]='f';

                    }
                }
                catch(e) {
                      testResults["testAbort"]=e.message;
                }
            }
            else {
                    testResults["testAbort"]='f';
            }
        }
    };
    try {
        request.open("GET", src + "response_text.html", true);
        request.send(null);
    }
    catch(e) {
                    testResults["testAbort"]=e.message;
    }
},

function testGetAllResponseHeaders()
{
 
   total += 2;
         var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 3) {
            try {
                if (request.getAllResponseHeaders() != null) {
                    testResults["testGetAllResponseHeaders3"]='p';
                }
                else {
                    testResults["testGetAllResponseHeaders3"]='f';
                }
            }
            catch(e) {
                  testResults["testGetAllResponseHeaders3"]=e.message;
            }
        }
        else if (request.readyState == 4) {
            try {
                if (request.getAllResponseHeaders() != null) {
                   testResults["testGetAllResponseHeaders4"]='p';
                }
                else {
                   testResults["testGetAllResponseHeaders4"]='f';
                }
            }
            catch(e) {
                                    testResults["testGetAllResponseHeaders4"]=e.message;

            }
        }
    };
    request.open("GET", src + "response_text.html", true);
    request.send(null);
},

function testGetAllResponseHeaders4()
{
   total += 1;
    var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 4) {
            try {
                var headers = request.getAllResponseHeaders().split("\n");
                var foundX = false;
                var foundStatus = false;
                for(var i = 0; i < headers.length; i++) {
                    if(headers[i] == "200 OK") {
                        foundStatus = true;
                    }
                }
                if (foundStatus) {
                    testResults["testGetAllResponseHeaders4NoStatusLine"]='f';
                }
                else {
                   testResults["testGetAllResponseHeaders4NoStatusLine"]='p';
                }
            }
            catch(e) {
                testResults["testGetAllResponseHeaders4NoStatusLine"]=e.message;
            }
        }
    };
    request.open("GET", src + "response_text.html", true);
    request.send(null);
},

function testOpen()
{
    total += 1;
   var request = getRequest();
    request.open("GET", src + "response_text.html", true);
    if(request.readyState == 1) {
        testResults["testOpenReadyState1"]='p';
    }
    else {
        testResults["testOpenReadyState1"]='f';
    }

    request.send(null);
},

function testSendReadyState()
{
	total += 5;
    var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 2) {
            try {
                request.send(null);
                testResults["testSendReadyState2"]='f';
            }
            catch(e) {
                testResults["testSendReadyState2"]='p';
            }
        }
        else if (request.readyState == 3) {
            try {
                request.send(null);
                testResults["testSendReadyState3"]='f';
            }
            catch(e) {
                testResults["testSendReadyState3"]='p';
            }
        }
        else if (request.readyState == 4) {
            try {
                request.send(null);
                testResults["testSendReadyState4"]='f';

            }
            catch(e) {
                testResults["testSendReadyState4"]='p';
            }
        }
    };
    try {
        request.send(null);
        testResults["testSendReadyState0"]='f';
    }
    catch(e) {
                testResults["testSendReadyState0"]='p';
    }
    request.open("GET", src + "response_text.html", true);
    try {
        request.send(null);
                testResults["testSendReadyState1"]='p';
    }
    catch(e) {
                testResults["testSendReadyState1"]='f';
    }
},

function testSetRequestHeader()
{
    
    total += 4;
   var request = getRequest();
    request.onreadystatechange = function()
    {
        if (request.readyState == 2) {
            try {
                request.setRequestHeader("Cookie", "name=value");
               testResults["testSetRequestHeader2"]='f';
             }
            catch(e) {
                testResults["testSetRequestHeader2"]='p';
            }
        }
        else if (request.readyState == 3) {
            try {
                request.setRequestHeader("Cookie", "name=value");
                testResults["testSetRequestHeader3"]='f';
            }
            catch(e) {
                testResults["testSetRequestHeader3"]='p';
            }
        }
    };
    try {
        request.setRequestHeader("Cookie", "name=value");
        testResults["testSetRequestHeader0"]='f';

    }
    catch(e) {
           testResults["testSetRequestHeader0"]='p';
    }
    request.open("GET", src + "response_text.html", true);
    try {
        request.setRequestHeader("X-Client", "X-Client");
        testResults["testSetRequestHeader1"]='p';
    }
    catch(e) {
        testResults["testSetRequestHeader1"]=e.message;
    }
    request.send(null);
}

];

function getRequest()
{
    var sendRequest;
    if (window.XMLHttpRequest) {
        sendRequest = new XMLHttpRequest();
    }
    else if (window.ActiveXObject) {
        try {
            sendRequest = new ActiveXObject("Microsoft.XMLHTTP");
        }
        catch(e) {
            try {
                sendRequest = new ActiveXObject("Msxml2.XMLHTTP");
            }
            catch (e) {
                alert("Could not create httpRequest");
            }
        }
    }
    return sendRequest;
}


function report(msg) {
 log += msg +  "\n";
}

passLog = "";
failLog = "";


function runTests() {

if(index <  tests.length) {

document.getElementById('tips').innerHTML = "Waiting..."

     try {
        	tests[index]();
        }
      catch (e) {
       report("test " + index + " exception raised: " + e.message)
      } 
       index += 1;
      setTimeout(runTests, delay);
    }
    
   else{
   
    for (var key in testResults){
		if( testResults[key] == 'p') {
			pass++;
			passLog += key + " passed\n";	
			}
		else if (testResults[key] == 'f'){
			fail++;
			failLog += key + " failed \n";
			}
		else {
			error++;
			failLog += key + " expection: " + testResults[key];
			}	
       }//end for
//total = pass + fail + error;
      
document.getElementById('total').innerHTML = total;
document.getElementById('pass').innerHTML = pass;
document.getElementById('fail').innerHTML = fail;
document.getElementById('tips').innerHTML = "Done";

no_response = total - pass - fail - error;
document.getElementById('no_response').innerHTML = no_response;


    }//end else index

}



function createReport() {
log = log.replace(/&/g,'&amp;').replace(RegExp('<', 'g'), '&lt;').replace('\0', '\\0') ;
failLog.replace(/&/g,'&amp;').replace(RegExp('<', 'g'), '&lt;').replace('\0', '\\0'); 
passLog.replace(/&/g,'&amp;').replace(RegExp('<', 'g'), '&lt;').replace('\0', '\\0'); 
     
 var w = window.open();
      w.document.write('<pre><b>Failed ' + (fail) + ' of ' + total + ' tests.</b>\n' + log + '\n<b>Fail Tests:</b>\n' + failLog + '\n<b>Pass Tests:</b>\n' + passLog + '\n' +  '<\/pre>');
      w.document.close();
   }     


